#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		__python	/usr/bin/python3
%define		cups_datadir	%(cups-config --datadir   2>/dev/null || echo ERROR)
%define		cups_serverdir	%(cups-config --serverbin 2>/dev/null || echo ERROR)

%define		cups_mimedir	%{cups_datadir}/mime
%define		cups_ppddir	%{cups_datadir}/model
%define		cups_filterdir	%{cups_serverdir}/filter
%define		cups_backenddir	%{cups_serverdir}/backend

#-----------------------------------------------------------------------------
Name		:	hplip
Version		:	3.22.10
Release		:	17.0.10.rel%{?dist}
Summary		:	HP Linux Imaging and Printing Project
Group		:	System Environment/Daemons

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	BSD+GPLv2
URL		:	https://sourceforge.net/projects/hplip/
#https://developers.hp.com/hp-linux-imaging-and-printing/gethplip

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz
Patch0		:	%{name}-%{version}-nolibImage-1.patch
Patch1		:	%{name}-%{version}-plugin-udevissues.patch

#-----------------------------------------------------------------------------
BuildRequires	:	avahi
BuildRequires	:	cups-devel
BuildRequires	:	dbus-devel
BuildRequires	:	dbus-python-devel
BuildRequires	:	libjpeg-turbo-devel
BuildRequires	:	libusb
BuildRequires	:	net-snmp-devel
BuildRequires	:	python3
BuildRequires	:	polkit

Requires	:	cups-devel
Requires	:	dbus-python
Requires	:	ghostscript
Requires	:	gnupg
Requires	:	net-snmp-devel
Requires	:	python3-pygobject
Requires	:	python-distro
Requires	:	sane-backends
Requires	:	usbutils
Requires	:	xsane
#-----------------------------------------------------------------------------
%description
The Hewlett-Packard Linux Imaging and Printing Project provides
drivers for HP printers and multi-function peripherals.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/hp/%{name}.conf
%{_sysconfdir}/udev/rules.d/*.rules
%{_sysconfdir}/xdg/autostart/%{name}-*.desktop
%{_bindir}/hp-*
%{_bindir}/hpijs
%{_defaultdocdir}/%{name}-%{version}/*
%{_prefix}/lib/cups/filter/foomatic-rip-hplip
%{_prefix}/lib/cups/filter/hpcups*
%{_prefix}/lib/cups/filter/hpps
%{_prefix}/lib/cups/filter/pstotiff
%{_prefix}/lib/cups/backend/hp
%{_prefix}/lib/cups/backend/hpfax
%{_libdir}/libhp*.{la,so*}
%{_datadir}/cups/*
%{_datadir}/hal/*
%{_datadir}/hplip/dat2drv
%{_datadir}/hplip/%{name}_clean.sh
%{_datadir}/hplip/base/pexpect/__init__.py
%{_datadir}/hplip/fax/pstotiff*
%{_datadir}/hplip/*.py
%{_datadir}/hplip/*/*.py
%{_datadir}/applications/hp*.desktop
%{_datadir}/hplip/data/images/*/*.png
%{_datadir}/hplip/data/models/models.dat
%{_datadir}/hplip/data/localization/%{name}_*.qm
%{_datadir}/hplip/data/ldl/*.gz
%{_datadir}/hplip/data/pcl/*.gz
%{_datadir}/hplip/data/ps/*.gz
%{_datadir}/hplip/locatedriver
%{_datadir}/hplip/installer/distros.dat
%{python3_sitelib}/*.so

#=============================================================================
%prep
%setup -q
#CAUTION! to get rid of all libImageProcessor references
#{__rm} prnt/hpcups/libImageProcessor-x86*
%patch -P 0 -p1
%patch -P 1 -p1

#-----------------------------------------------------------------------------
#building application
%build

#adding osukiss specific
tar xf %{SOURCE1}

# Change shebang /usr/bin/env python -> %{__python}
find -name '*.py' -print0 | xargs -0 			\
  sed							\
    -i.env-python					\
    -e 's,^#!/usr/bin/env python,#!%{__python},'

sed							\
  -i.env-python						\
  -e 's,^#!/usr/bin/env python,#!%{__python},'	\
  prnt/filters/hpps					\
  fax/filters/pstotiff

#inserting osukiss distribution reference
sed -i							\
  -e "/'lfs': 'su',/a \\\\t      'osukiss': 'su',"	\
  base/password.py					\
  base/password.py.env-python
sed -i							\
  -e "s:,lfs,:,osukiss,lfs,:"				\
  installer/distros.dat

%{__cat} 						\
	%{name}-ok_addon/osukiss-distros.dat		\
	>> installer/distros.dat

sed -i							\
  -e 's|^AM_INIT_AUTOMAKE|AM_INIT_AUTOMAKE([foreign])|g'\
  configure.in

PYTHON=%{__python}					\
autoconf -v -i -f

export CFLAGS="%{optflags} $(python3-config --includes)"
export CXXFLAGS="%{optflags} $(python3-config --includes)"
 
PYTHON=%{__python}					\
./configure						\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}			\
	--exec-prefix=%{_exec_prefix}			\
	--libexecdir=%{_libexecdir}			\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--localstatedir=%{_var}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--enable-udev-acl-rules				\
	--disable-qt3					\
	--disable-qt4					\
	--enable-qt5					\
	--disable-policykit				\
	--disable-libusb01_build			\
	--disable-imageProcessor-build			\
	--disable-scan-build				\
	--disable-udev_sysfs_rules			\
	--enable-doc-build				\
	--enable-fax-build				\
	--enable-dbus-build				\
	--enable-cups-drv-install			\
	--enable-cups-ppd-install			\
	--enable-foomatic-drv-install			\
	--enable-foomatic-ppd-install			\
	--enable-foomatic-rip-hplip-install		\
	--enable-hpcups-install				\
	--enable-hpijs-install				\
	--enable-network-build				\
	--with-cupsbackenddir=%{cups_backenddir} 	\
	--with-cupsfilterdir=%{cups_filterdir}		\
	--with-hpppddir=%{cups_ppddir}			\
	--with-mimedir=%{_datadir}/cups/mime		\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}						\
	%{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	-j 1						\
	DESTDIR=%{buildroot}				\
	install

#removing systemd reference
%{__rm} -fr %{buildroot}%{_prefix}/lib/systemd

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

#-----------------------------------------------------------------------------
%changelog
